/* $Id: console.c,v 1.5 2000/11/15 17:44:55 apc Exp $ */
/* Copyright 2000  AG Electronics Ltd. */
/* This code is distributed without warranty under the GPL v2 (see COPYING) */

#include <console.h>
#include <malloc.h>
#include <ctype.h>

static gbios_console_device *first_console;

int register_console_device (const gbios_console_fn * fn, char *name, void *data)
{
    gbios_console_device *device = malloc (sizeof (gbios_console_device));

    if (device)
    {
	device->next = first_console;
	first_console = device;
	device->fn = fn;
	device->name = name;
	device->data = data;
	console_output ("Registered console ");
	console_output (name);
	console_output ("\n");
	return 0;
    }
    else
	return -1;
}

void console_outchar(char c)
{
    gbios_console_device *con;

    for (con = first_console; con; con = con->next)
	con->fn->output (con->data, c);

    if (c == '\n')
	for (con = first_console; con; con = con->next)
	    con->fn->output (con->data, '\r');
}

void console_output (const char *c)
{
    while (*c)
    {
	console_outchar(*c);
	c++;
    }
}

int console_input (void)
{
    gbios_console_device *con;

    for (con = first_console; con; con = con->next)
    {
	int x = con->fn->input (con->data);

	if (x != -1)
	    return x;
    }

    return -1;
}

void print_spinner(int x)
{
    console_outchar("\\|/-"[x % 4]);
    console_outchar('\b');
}
