/* $Id: bsp.h,v 1.7 2000/11/15 17:44:55 apc Exp $ */
/* Copyright 2000  AG Electronics Ltd. */
/* This code is distributed without warranty under the GPL v2 (see COPYING) */

#ifndef _GBIOS_BSP_H
#define _GBIOS_BSP_H

/* This function is called very early on, and may not have a functioning
   stack. It should be careful not to touch memory until it has enable
   memory accesses. */
void bsp_init_memory(void);

/* Called before the relocation jump - data has been relocated. */
void bsp_init_pre_reloc(unsigned offset);

/* This function is called immediately after relocation. Do whatever
   is necessary to perform printf. */
void bsp_init_post_reloc(void);

/* Called after the first print to the outside world */
void bsp_init_post_hello(void);

/* Called if things have failed very, very badly. */
void bsp_indicate_dead(void);

/* Prints out a BSP description */
void bsp_identify(void);

/* BSP primary clock */
unsigned bsp_clock_speed(void);

/* Start a loaded executable */
void bsp_run_executable(unsigned entry, char *cmd_line,
         unsigned initrd_start, unsigned initrd_length);

/* Check mailboxes for PCI agents */
void bsp_mailbox_check(void);

/* Memory regions - all of memory runs from memory_base to top. The middle
   region from bios_base to top must not be touched. */
extern unsigned long memory_base;
extern unsigned long bios_base;
extern unsigned long bios_top;
extern unsigned long memory_top;

#endif
