/* $Id: console.h,v 1.5 2000/11/15 17:44:55 apc Exp $ */
/* Copyright 2000  AG Electronics Ltd. */
/* This code is distributed without warranty under the GPL v2 (see COPYING) */
/* Definitions for console devices */

#ifndef _GBIOS_CONSOLE_H
#define _GBIOS_CONSOLE_H

typedef struct gbios_console_fn
{
    void (* output)(void *data, char c);
    int (* input)(void *data);
} gbios_console_fn;

typedef struct gbios_console_device
{
    const gbios_console_fn *fn;
    void *data;
    char *name;
    struct gbios_console_device *next;
} gbios_console_device;

int register_console_device(const gbios_console_fn *fn, char *name, void *data);

void console_output(const char *c);
void console_outchar(char c);
int console_input(void);
char console_blocking_input(void);

int init_console_16550(unsigned base, unsigned hertz, int spacing);
void print_spinner(int x);

#endif
