/* $Id: flash.h,v 1.4 2000/11/15 17:44:55 apc Exp $ */
/* Copyright 2000  AG Electronics Ltd. */
/* This code is distributed without warranty under the GPL v2 (see COPYING) */

#ifndef _GBIOS_FLASH_H
#define _GBIOS_FLASH_H

typedef struct gbios_flash_fn
{
    const char *(* identify)(void *data);
    void *(* ptr)(void *data);
    int (* erase_all)(void *data);
    int (* erase)(void *data, unsigned offset, unsigned length);
    int (* program)(void *data, unsigned offset, void *source, unsigned length);    
} gbios_flash_fn;

typedef struct gbios_flash_device
{
    gbios_flash_fn *fn;
    char *tag;
    void *data;
    unsigned base;
    unsigned size;
    struct gbios_flash_device *next;
} gbios_flash_device;

int register_flash_device(gbios_flash_fn *fn, char *tag, void *data,
        unsigned base, unsigned size);
int flash_program(char *tag, void *source, unsigned length);
int init_flash_amd800(char *tag, unsigned base, unsigned spacing);
int init_flash_atmel040(char *tag, unsigned base, unsigned spacing);

void do_flash(int argc, char **argv, void *data);

#endif
