/* $Id: malloc.h,v 1.2 2000/11/15 17:44:55 apc Exp $ */
/* Copyright 2000  AG Electronics Ltd. */
/* This code is distributed without warranty under the GPL v2 (see COPYING) */

#ifndef _GBIOS_MALLOC_H
#define _GBIOS_MALLOC_H

#include <sys/types.h>

#ifdef	__cplusplus
extern "C" {
#endif

/** Add a region of memory to the shared pool. This allows a fragmented memory
pool, which is useful if some of the shared regions is occupied by the I2O
queues. */
void malloc_add_pool(void *base, size_t size);
/** Free memory within the shared pool. */
void free(void *ptr);
/** Allocate memory within the shared pool. */
void *malloc(size_t size);
void malloc_list (void);

#ifdef	__cplusplus
}
#endif

#endif
