/* $Id: nvram.h,v 1.3 2000/11/15 17:44:55 apc Exp $ */
/* Copyright 2000  AG Electronics Ltd. */
/* This code is distributed without warranty under the GPL v2 (see COPYING) */
/* Definitions for nvram devices - these are flash or eeprom devices used to
   store information across power cycles and resets. Though they are byte
   addressable, writes must be committed to allow flash devices to write
   complete sectors. */

#ifndef _GBIOS_NVRAM_H
#define _GBIOS_NVRAM_H

typedef struct gbios_nvram_device
{
    unsigned size(void *data);
    unsigned char read_byte(void *data, unsigned offset);
    unsigned char write_byte(void *data, unsigned offset, unsigned char *byte);
    void commit(void *data);
} gbios_nvram_device;

#endif
