/* $Id: ppc.h,v 1.8 2000/11/15 17:44:55 apc Exp $ */
/* Copyright 2000  AG Electronics Ltd. */
/* This code is distributed without warranty under the GPL v2 (see COPYING) */

#ifndef _GBIOS_PPC_H
#define _GBIOS_PPC_H

#define BIG_ENDIAN
#define ELF_THIS_MACHINE EM_PPC

#define RODATA __attribute__ ((__section__ (".rodata"))) 

#include "iotypes.h"
u16 swap_16(u16 x);
u32 swap_32(u32 x);

#define cpu_to_be16(x) (x)
#define cpu_to_be32(x) (x)
#define be16_to_cpu(x) (x)
#define be32_to_cpu(x) (x)
#define cpu_to_le16(x) swap_16(x)
#define cpu_to_le32(x) swap_32(x)
#define le16_to_cpu(x) swap_16(x)
#define le32_to_cpu(x) swap_32(x)

/* Do CPU specific setup, with optional icache */
void ppc_setup_cpu(int icache);

void ppc_enable_dcache(void);
void ppc_disable_dcache(void);
void ppc_enable_mmu(void);

/* Describe which sort of ppc CPU I am */
void ppc_identify(void);

/* Setup memory mappings */
void ppc_set_ibats(unsigned base, unsigned length);
void ppc_set_ibats_reloc(unsigned virtual, unsigned physical, unsigned length);

void ppc_set_memory_dbat(unsigned length);
void ppc_set_io_dbat(int bat, unsigned base, unsigned length);
void ppc_set_io_dbat_reloc(int bat, unsigned base, unsigned phys, unsigned length);
void ppc_set_mem_dbat_reloc(int bat, unsigned base, unsigned phys, unsigned length);
/* For cacheable roms */
void ppc_set_rom_dbat(int bat, unsigned base, unsigned length);

/* Flush icache, etc */
void make_coherent(void *base, unsigned length);

/* And run it */
void ppc_run_executable(unsigned base, ...);

#endif
