/* $Id: mpc107.c,v 1.2 2000/11/15 17:44:55 apc Exp $ */
/* Copyright 2000  AG Electronics Ltd. */
/* This code is distributed without warranty under the GPL v2 (see COPYING) */

#include <malloc.h>
#include <stdio.h>
#include <pci.h>

struct register_table {
    char *name;
    unsigned address;
    unsigned size;
};

const struct register_table mpc107_table[] = {
    {"PMCR1", 0x70, 2},
    {"PMCR2", 0x72, 1},
    {"ODCR", 0x73, 1},
    {"CLK driver control", 0x74, 2},
    {"MIOCR", 0x76, 1}, 
    {"EUMBBAR", 0x78, 4},
    {"MemStart 1", 0x80, 4},
    {"MemStart 2", 0x84, 4},
    {"ExtMemStart 1", 0x88, 4},
    {"ExtMemStart 2", 0x8c, 4},
    {"MemEnd 1", 0x90, 4},
    {"MemEnd 2", 0x94, 4},
    {"ExtMemEnd 1", 0x98, 4},
    {"ExtMemEnd 2", 0x9c, 4}, 
    {"MBEN", 0xa0, 1},
    {"Page Mode CNTR", 0xa3, 1},
    {"PICR1", 0xa8, 4},
    {"PICR2", 0xac, 4},
    {"Map B Options", 0xe0, 1},
    {"MCCR1", 0xf0, 4},
    {"MCCR2", 0xf4, 4},
    {"MCCR3", 0xf8, 4},
    {"MCCR4", 0xfc, 4},
    {NULL, 0, 0}
};

void dump_107(int argc, char **argv)
{
   int i;
    
    for(i = 0; mpc107_table[i].name; i++)
    {
        u8 d8;
        u16 d16;
        u32 d32;
        
        printf("0x%02x: ", mpc107_table[i].address);
        switch (mpc107_table[i].size)
        {
            case 1:
                pci_config_read_8(0,0,0, mpc107_table[i].address, &d8);
                printf("0x%02x      ", d8);
                break;
            case 2:
                pci_config_read_16(0,0,0, mpc107_table[i].address, &d16);
                printf("0x%04x    ", d16);
                break;
            case 4:
                pci_config_read_32(0,0,0, mpc107_table[i].address, &d32);
                printf("0x%08lx", d32);
                break;
        }
        printf(" (%s)\n", mpc107_table[i].name);
    }    
}
