/* $Id: prep.c,v 1.4 2000/11/15 17:44:55 apc Exp $ */
/* Copyright 2000  AG Electronics Ltd. */
/* This code is distributed without warranty under the GPL v2 (see COPYING) */

#include <pci.h>

unsigned __pci_config_read_32(unsigned address);
unsigned __pci_config_read_16(unsigned address);
unsigned __pci_config_read_8(unsigned address);
void __pci_config_write_32(unsigned address, unsigned data);
void __pci_config_write_16(unsigned address, unsigned short data);
void __pci_config_write_8(unsigned address, unsigned char data);

int pci_config_read_32(int bus, int dev, int func, int reg, u32 *data)
{
    /* Check for master abort, which indicates an absent device */
    __pci_config_write_16(0x80000006, 0x2000);
    *data = __pci_config_read_32(bus << 16 | dev << 11 | 
                func << 8 | reg | 0x80000000);
    if (__pci_config_read_16(0x80000006) & 0x2000)
    {
        __pci_config_write_16(0x80000006, 0x2000);
        return -1;
    }
    else
        return 0;
}
int pci_config_read_16(int bus, int dev, int func, int reg, u16 *data)
{
    __pci_config_write_16(0x80000006, 0x2000);
    *data = __pci_config_read_16(bus << 16 | dev << 11 | 
                func << 8 | reg | 0x80000000);
    if (__pci_config_read_16(0x80000006) & 0x2000)
    {
        __pci_config_write_16(0x80000006, 0x2000);
        return -1;
    }
    else
        return 0;
}
int pci_config_read_8(int bus, int dev, int func, int reg, u8 *data)
{
    __pci_config_write_16(0x80000006, 0x2000);
    *data = __pci_config_read_8(bus << 16 | dev << 11 | 
                func << 8 | reg | 0x80000000);
    if (__pci_config_read_16(0x80000006) & 0x2000)
    {
        __pci_config_write_16(0x80000006, 0x2000);
        return -1;
    }
    else
        return 0;
}
void pci_config_write_32(int bus, int dev, int func, int reg, u32 data)
{
    __pci_config_write_32(bus << 16 | dev << 11 | 
                func << 8 | reg | 0x80000000, data);
}
void pci_config_write_16(int bus, int dev, int func, int reg, u16 data)
{
    __pci_config_write_16(bus << 16 | dev << 11 | 
                func << 8 | reg | 0x80000000, data);
}
void pci_config_write_8(int bus, int dev, int func, int reg, u8 data)
{
    __pci_config_write_8(bus << 16 | dev << 11 | 
                func << 8 | reg | 0x80000000, data);
}

void *pci_to_local(ioaddr addr)
{
    return (void *)(addr);
}

ioaddr local_to_pci(volatile void *addr)
{
    return (ioaddr)addr;
}
