/* $Id: crt0.S,v 1.6 2000/11/15 17:44:55 apc Exp $ */
/* Copyright 2000  AG Electronics Ltd. */
/* This code is distributed without warranty under the GPL v2 (see COPYING) */

#include <asmstart.h>
#define ASM
#include "ppcreg.h"
#include <ppc_asm.tmpl>

.globl __start
.globl _start
.globl __bss_end
.globl __start_address_check

.globl bsp_init_memory
    /* .org 0x100 8*/
_start:
__start:
        isync
/* Disable dcache and MMU, so that init_memory stands a chance */   
        li      0, 0
        mtspr 1008, 0
        sync
        mtmsr 0 
        sync
#ifdef BSP_LIFE_SIGNS
        bl bsp_life_signs
#endif
/* FAKERAM - this is a 128KB BAT covering the __start_data address.
 We allocate it in the cache so that we can continue running and report a
 memory failure in early startup code. 
 
 DBAT 0 is used for the FAKERAM.
 DBAT 1 is kept for walking around memory under test.
 DBATs 2 and 3 are used for IO. 
 */

#ifdef BSP_USE_FAKERAM
        /* Step 1 - prepare DBATs */
        lis     r2, __start_data@h
        ori     r3, r2, 0x0003
        ori     r2, r2, 0x0002
        mtdbatu 0, r3
        mtdbatl 0, r2
        li      r3, 0x0003
        li      r2, 0x0022
        mtdbatu 1, r3
        mtdbatl 1, r2
        lis     r2, BSP_IOREGION1@h
        ori     r3, r2, BSP_IOMASK1 | 0x0003
        ori     r2, r2, 0x0022
        mtdbatu 2, r3
        mtdbatl 2, r2
        lis     r2, BSP_IOREGION2@h
        ori     r3, r2, BSP_IOMASK2 | 0x0003
        ori     r2, r2, 0x0022
        mtdbatu 3, r3
        mtdbatl 3, r2
        
        /* Step 2 - enable dcache */
        mfspr   2, HID0
        ori     2, 2, HID0_DCE | HID0_DCI
        mtspr   HID0, 2
        sync
        
        /* Step 3 - enable MMU */
        mfmsr   2
        ori     2, 2, MSR_DR
        mtmsr   2
        sync
        
        /* Step 4 - create fakeram with dcbz */
        lis     r2, __start_data@h
        li      r3, 1024
        mtctr   r3
make_ram_loop:
        dcbz    r0, r2
        addi    r2, r2, 32
        bdnz    make_ram_loop
#endif    
        /* Turn on memory */
        bl bsp_init_memory
/* init stack pointer  */
        lis     1, __stack_end@ha
        addi    1, 1, __stack_end@l
	stwu	0,-64(1) 
/* Set up the EABI pointers, before we enter any C code */        
	lis	13,_SDA_BASE_@ha
        addi    13,13,_SDA_BASE_@l
        lis     2,_SDA2_BASE_@ha
        addi    2,2,_SDA2_BASE_@l

/* Find out the address we're running at: */
        bl __start_address_check
__start_address_check:
        mflr    3
        bl      init
