/* $Id: init.c,v 1.5 2000/11/15 17:44:55 apc Exp $ */
/* Copyright 1999-2000  AG Electronics Ltd. */
/* This code is distributed without warranty under the GPL v2 (see COPYING) */

/* At this point we have a stack. We still potentially need to relocate code
   and data, and we can consider turning the instruction cache on. */

#include <asmstart.h>

extern const int (*init2_ptr)(void);

void init(unsigned *address)
{
    extern unsigned __bss_start[], __bss_end[];
    extern unsigned __start[];
    extern unsigned __start_address_check[];
    extern unsigned __end_text[];
    extern unsigned __start_data[];
    extern unsigned __end_data[];
    unsigned *to;
    unsigned *from;
    
    /* Relocate code and data if necessary */
    if (address != __start_address_check)
    {
#ifdef BSP_USE_FAKERAM
        to = __start_data;
        from = address - __start_address_check + __end_text;
#else
        to = __start;
        from = address - (__start_address_check - __start);
#endif
    }    
    else if (__start_data != __end_text)
    {
        /* Always relocate data */
        to = __start_data;
        from = __end_text;
    }
    else
        to = __end_data;

    while(to < __end_data)
        *to++ = *from++;    
    
    /* Clear bss */
    for(to = __bss_start; to < __bss_end; to++)
        *to = 0;  

    /* BSPs that use fakeram have to relocate their code segments in here */
    bsp_init_pre_reloc(sizeof(unsigned) * (address - __start_address_check));
        
    /* Chip specific register setup */
    init2_ptr();
}
